'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _focusManager = require('../helpers/focusManager');

var focusManager = _interopRequireWildcard(_focusManager);

var _styles = require('../helpers/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ESC_KEY = 27;

var OffCanvas = function (_Component) {
  _inherits(OffCanvas, _Component);

  function OffCanvas() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, OffCanvas);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = OffCanvas.__proto__ || Object.getPrototypeOf(OffCanvas)).call.apply(_ref, [this].concat(args))), _this), _this.open = function () {
      if (_this.props.returnFocusAfterClose) {
        focusManager.focusLater();
      }

      if (_this.props.trapFocusAfterOpen) {
        focusManager.setFocusTrap(_this.content);
      }

      _this.focusContent();
    }, _this.close = function () {
      if (_this.props.returnFocusAfterClose) {
        focusManager.returnFocus();
      }

      if (_this.props.trapFocusAfterOpen) {
        focusManager.removeFocusTrap();
      }
    }, _this.parentHandlesClose = function (event) {
      if (_this.props.onClose) {
        _this.props.onClose(event);
      }
    }, _this.handleOnOverlayClick = function (event) {
      if (_this.props.closeOnOverlayClick && event.target === _this.overlay) {
        _this.parentHandlesClose(event);
      }
    }, _this.handleOnEscDown = function (event) {
      if (_this.props.closeOnEsc && event.keyCode === ESC_KEY) {
        _this.parentHandlesClose(event);
      }
    }, _this.setOverlayRef = function (overlay) {
      _this.overlay = overlay;
    }, _this.setContentRef = function (content) {
      _this.content = content;
    }, _this.focusContent = function () {
      return _this.content && _this.content.focus();
    }, _this.getExtraStyles = function () {
      var _this$props = _this.props,
          className = _this$props.className,
          overlayClassName = _this$props.overlayClassName;

      // Remove extra styles when classNames are passed

      var overlayStyles = overlayClassName ? {} : OffCanvas.extraStyles.overlay;
      var contentStyles = className ? {} : OffCanvas.extraStyles.content;

      return {
        overlay: overlayStyles,
        content: contentStyles
      };
    }, _this.getStyles = function () {
      var _this$props2 = _this.props,
          isOpen = _this$props2.isOpen,
          width = _this$props2.width,
          height = _this$props2.height,
          position = _this$props2.position,
          style = _this$props2.style;

      var extraStyles = _this.getExtraStyles();

      var styles = (0, _styles2.default)(OffCanvas.defaultStyles, extraStyles, isOpen, width, height, position, style);

      return styles;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(OffCanvas, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.isOpen) {
        this.open();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.isOpen && !prevProps.isOpen) {
        this.open();
      } else if (!this.props.isOpen && prevProps.isOpen) {
        this.close();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isOpen = _props.isOpen,
          role = _props.role,
          label = _props.label,
          labelledby = _props.labelledby,
          className = _props.className,
          overlayClassName = _props.overlayClassName;


      var styles = this.getStyles();

      return _react2.default.createElement(
        'div',
        {
          ref: this.setOverlayRef,
          style: styles.overlay,
          className: overlayClassName,
          onClick: this.handleOnOverlayClick,
          'data-testid': 'overlay'
        },
        _react2.default.createElement(
          'div',
          {
            ref: this.setContentRef,
            style: styles.content,
            className: className,
            onKeyDown: this.handleOnEscDown,
            role: role,
            'aria-label': label,
            'aria-labelledby': labelledby,
            'aria-hidden': !isOpen,
            tabIndex: '-1',
            'data-testid': 'content'
          },
          this.props.children
        )
      );
    }
  }]);

  return OffCanvas;
}(_react.Component);

OffCanvas.defaultProps = {
  isOpen: false,
  width: '300px',
  height: '300px',
  position: 'left',
  closeOnEsc: true,
  closeOnOverlayClick: true,
  trapFocusAfterOpen: true,
  returnFocusAfterClose: true,
  style: {
    overlay: {},
    content: {}
  }
};
OffCanvas.propTypes = {
  isOpen: _propTypes2.default.bool.isRequired,
  width: _propTypes2.default.string,
  height: _propTypes2.default.string,
  position: _propTypes2.default.oneOf(['left', 'right', 'top', 'bottom']),
  onClose: _propTypes2.default.func,
  closeOnEsc: _propTypes2.default.bool,
  closeOnOverlayClick: _propTypes2.default.bool,
  trapFocusAfterOpen: _propTypes2.default.bool,
  returnFocusAfterClose: _propTypes2.default.bool,
  style: _propTypes2.default.shape({
    overlay: _propTypes2.default.object,
    content: _propTypes2.default.object
  }),
  className: _propTypes2.default.string,
  overlayClassName: _propTypes2.default.string,
  role: _propTypes2.default.string,
  label: _propTypes2.default.string,
  labelledby: _propTypes2.default.string,
  children: _propTypes2.default.node
};
OffCanvas.defaultStyles = {
  overlay: {
    position: 'fixed',
    top: 0,
    left: 0,
    width: '100%',
    height: '100%',
    zIndex: '900'
  },
  content: {
    position: 'fixed',
    zIndex: '1000',
    outline: 0
  }
};
OffCanvas.extraStyles = {
  overlay: {
    background: 'rgba(255, 255, 255, 0.5)'
  },
  content: {
    background: 'rgba(0, 0, 0, 0.1)',
    transition: '0.25s ease-out'
  }
};
exports.default = OffCanvas;