'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeFocusTrap = exports.setFocusTrap = exports.returnFocus = exports.focusLater = undefined;

var _tabbable = require('./tabbable');

var TAB_KEY = 9;

var lastFocusedElement = undefined;
var tabbable = undefined;

var focusLater = exports.focusLater = function focusLater() {
  lastFocusedElement = document.activeElement;
};

var returnFocus = exports.returnFocus = function returnFocus() {
  if (lastFocusedElement) {
    lastFocusedElement.focus();
    lastFocusedElement = null;
  }
};

var setFocusTrap = exports.setFocusTrap = function setFocusTrap(element) {
  tabbable = (0, _tabbable.setTabbable)(element);
  document.addEventListener('keydown', focusTrap, true);
};

var removeFocusTrap = exports.removeFocusTrap = function removeFocusTrap() {
  document.removeEventListener('keydown', focusTrap, true);
  tabbable = null;
};

var isTabKey = function isTabKey(event) {
  return event.keyCode === TAB_KEY;
};

// Don't let focus to leave tabbable elements
var focusTrap = function focusTrap(event) {
  if (!isTabKey(event)) return;

  if (event.shiftKey) {
    // If focus is on the first element, move focus to the last element
    if (event.target === tabbable.first) {
      event.preventDefault();
      tabbable.last.focus();
    }
  } else {
    // If focus is on the last element, move focus to the first element
    if (event.target === tabbable.last) {
      event.preventDefault();
      tabbable.first.focus();
    }
  }
};